



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>浅析MySQL中concat以及group_concat的使用</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">浅析MySQL中concat以及group_concat的使用</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-23 17:20:34 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<div>
<div>
</div>
<div>
<div>&nbsp;</div>
</div>
</div>
</div>
<div>
<div>
<p>说明：</p>
<p>本文中使用的例子均在下面的数据库表tt2下执行：</p>
<p><img referrerpolicy="no-referrer"src="https://img-blog.csdn.net/20170801164739367?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQvTWFyeTE5OTIwNDEw/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></p>
<h1>一、concat()函数</h1>
<p>1、功能：将多个字符串连接成一个字符串。</p>
<p>2、语法：concat(str1, str2,...)</p>
<p>返回结果为连接参数产生的字符串，如果有任何一个参数为null，则返回值为null。</p>
<p>3、举例：</p>
<p>例1:select concat (id, name, score) as info from tt2;</p>
<p><img referrerpolicy="no-referrer"src="https://img-blog.csdn.net/20170801165220173?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQvTWFyeTE5OTIwNDEw/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></p>
<p>中间有一行为null是因为tt2表中有一行的score值为null。</p>
<p>例2：在例1的结果中三个字段id，name，score的组合没有分隔符，我们可以加一个逗号作为分隔符：</p>
<p><img referrerpolicy="no-referrer"src="https://img-blog.csdn.net/20170801165559634?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQvTWFyeTE5OTIwNDEw/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></p>
<p>这样看上去似乎顺眼了许多～～</p>
<p>但是输入sql语句麻烦了许多，三个字段需要输入两次逗号，如果10个字段，要输入九次逗号...麻烦死了啦，有没有什么简便方法呢？&mdash;&mdash;于是可以指定参数之间的分隔符的concat_ws()来了！！！</p>
<h1>二、concat_ws()函数</h1>
<p>1、功能：和concat()一样，将多个字符串连接成一个字符串，但是可以一次性指定分隔符～（concat_ws就是concat with&nbsp;<a href="https://www.baidu.com/s?wd=separator&amp;tn=24004469_oem_dg&amp;rsv_dl=gh_pl_sl_csd" rel="external nofollow noreferrer">separator</a>）</p>
<p>2、语法：concat_ws(separator, str1, str2, ...)</p>
<p>说明：第一个参数指定分隔符。需要注意的是分隔符不能为null，如果为null，则返回结果为null。</p>
<p>3、举例：</p>
<p>例3:我们使用concat_ws()将 分隔符指定为逗号，达到与例2相同的效果：</p>
<p><img referrerpolicy="no-referrer"src="https://img-blog.csdn.net/20170801170815291?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQvTWFyeTE5OTIwNDEw/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></p>
<p>例4：把分隔符指定为null，结果全部变成了null：</p>
<p><img referrerpolicy="no-referrer"src="https://img-blog.csdn.net/20170801171008771?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQvTWFyeTE5OTIwNDEw/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></p>
<h1>三、group_concat()函数</h1>
<p>前言：在有group by的查询语句中，select指定的字段要么就包含在group by语句的后面，作为分组的依据，要么就包含在聚合函数中。（有关group by的知识请戳：<a href="http://blog.csdn.net/mary19920410/article/details/76398050" rel="external nofollow noreferrer">浅析SQL中Group By的使用</a>）。</p>
<p>例5：</p>
<p><img referrerpolicy="no-referrer"src="https://img-blog.csdn.net/20170801172101877?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQvTWFyeTE5OTIwNDEw/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></p>
<p>该例查询了name相同的的人中最小的id。如果我们要查询name相同的人的所有的id呢？</p>
<p>当然我们可以这样查询：</p>
<p>例6：</p>
<p><img referrerpolicy="no-referrer"src="https://img-blog.csdn.net/20170801172456468?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQvTWFyeTE5OTIwNDEw/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></p>
<p>但是这样同一个名字出现多次，看上去非常不直观。有没有更直观的方法，既让每个名字都只出现一次，又能够显示所有的名字相同的人的id呢？&mdash;&mdash;使用group_concat()</p>
<p>1、功能：将group by产生的同一个分组中的值连接起来，返回一个字符串结果。</p>
<p>2、语法：group_concat( [distinct] 要连接的字段 [order by 排序字段 asc/desc &nbsp;] [separator '分隔符'] )</p>
<p>说明：通过使用distinct可以排除重复值；如果希望对结果中的值进行排序，可以使用order by子句；separator是一个字符串值，缺省为一个逗号。</p>
<p>3、举例：</p>
<p>例7：使用group_concat()和group by显示相同名字的人的id号：</p>
<p><img referrerpolicy="no-referrer"src="https://img-blog.csdn.net/20170801184419580?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQvTWFyeTE5OTIwNDEw/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></p>
<p>例8：将上面的id号从大到小排序，且用'_'作为分隔符：</p>
<p><img referrerpolicy="no-referrer"src="https://img-blog.csdn.net/20170801184623060?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQvTWFyeTE5OTIwNDEw/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></p>
<p>例9：上面的查询中显示了以name分组的每组中所有的id。接下来我们要查询以name分组的所有组的id和score：</p>
<p><img referrerpolicy="no-referrer"src="https://img-blog.csdn.net/20170801185841682?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQvTWFyeTE5OTIwNDEw/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></p>
<div>
<div>
<div>
<h1>MYSQL中group_concat有长度限制！默认1024</h1>
</div>
</div>
</div>
<div>
<div>
<div>详细说明如下：</p>
<p>用了group_concat后，select里如果使用了limit是不起作用的.</p></div>
<div>用group_concat连接字段的时候是有长度限制的，并不是有多少连多少。但你可以设置一下。</div>
<div>使用group_concat_max_len系统变量，你可以设置允许的最大长度。</div>
<div>程序中进行这项操作的语法如下，其中 val 是一个无符号整数：</div>
<div>SET [SESSION | GLOBAL] group_concat_max_len = val;</div>
<div>若已经设置了最大长度，则结果被截至这个最大长度。</div>
<div>在SQLyog中执行 SET GLOBAL group_concat_max_len = 10 后，重新打开SQLyog，设置就会生效。</div>
<div>---------------------------------------------------------------</div>
<div>GROUP_CONCAT将某一字段的值按指定的字符进行累加，系统默认的分隔符是逗号，可以累加的字符长度为1024字节。可以对这些参数进行修改。</div>
<div>1.先举一个简单的例子</div>
<div>&nbsp;&nbsp; select group_concat(f_a) from t_one group by f_b;</div>
<div>&nbsp;&nbsp; 按f_b进行分组查询，将每组中的f_a进行累加。</div>
<div>2.修改默认的分隔符</div>
<div>&nbsp;&nbsp; select group_concat(f_a&nbsp; separator&nbsp; '_') from t_one group by f_b;</div>
<div>&nbsp;&nbsp; separator&nbsp; 是一个关键字，后面跟着要进行分隔的字符</div>
<div>3.排序</div>
<div>&nbsp;&nbsp; select group_concat(f_a order by f_a&nbsp; separator&nbsp; '_') from t_one group by f_b;</div>
<div>4.修改默认字符大小</div>
<div>&nbsp;&nbsp; 1).在MySQL配置文件中加上</div>
<div>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; group_concat_max_len = 102400 #你要的最大长度</div>
<div>group_concat_max_len = -1 # -1为最大值或填入你要的最大长度</div>
<div>&nbsp;&nbsp;&nbsp; 2).可以简单一点，执行语句,可以设置作用范围</div>
<div>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; SET GLOBAL group_concat_max_len=102400;</div>
<div>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; SET SESSION group_concat_max_len=102400;</div>
<div>5.和concat使用</div>
<div>&nbsp;&nbsp;&nbsp; group_concat默认返回的是BLOB大对象，可以使用concat，返回字符串，还可以在返回的内容，在加入其它的数 据。</div>
</div>
</div>
</div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/m8zw7v8y.html">Redis简单案例&lpar;一&rpar; 网站搜索的热搜词</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9pj2749.html">leecode系列--Two Sum</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnnn13q.html">MyEclipse使用心得：集成和使用Maven的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvjjyyq.html">百度音乐api</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kd0v79.html">Java中&amp;quot&semi;&bsol;t&amp;quot&semi;表示几个空格</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mzgjrq.html">xcode 不显示占用内存</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9pro7dq.html">Gradle 脚本剪片---copy</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rv20e8.html">TCP&sol;IP包格式详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1o26r9.html">mysql给root开启远程访问权限，修改root密码</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1wz1k8.html">发布方配ASP&period;NET网站服务器</a>
		</li>
						<li><a href="https://www.batexi.com/a/96ow16y9.html">ubuntu10&period;04版本下android源码的编译</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ey1pkm9.html">WPF命中测试示例&lpar;二&rpar;&mdash;&mdash;几何区域命中测试</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pn4ny8.html">【mybatis深度历险系列】mybatis中的高级映射一对一、一对多、多对多</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpg0369.html">分布式进阶&lpar;十一&rpar; Docker 常见错误汇总</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jp56w8.html">关于&sol;tmp&sol; 目录自动清理文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwj6z6r8.html">PYTHON使用入门</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1j5109.html">idea开发maven项目热加载</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjmpv09.html">JSF的分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv217eo9.html">springboot项目js文件404</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwp31k8.html">SQL SERVER查询字段在哪个表里</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qwvn53k8.html">Forth 词典和词汇</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1ry4l08.html">二、fread与fwrite</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o1336xq.html">springBoot的数据库操作</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m2yxkoq.html">Linux命令学习之路-文档浏览之less</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e432ze9.html">Span&amp;lt&semi;T&amp;gt&semi;和ValueTuple&amp;lt&semi;T&amp;gt&semi;性能是&period;Net Core非常关键的特性</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7o2wkk8.html">优雅的使用列表推导式和lambda</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7o2v3j8.html">PythonStudy1&mdash;&mdash;Python 值拷贝 浅拷贝 深拷贝</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m2y4k0q.html">Python调用ffpmeg和ffprobe处理视频文件</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyy63kxq.html">zabbix安装、部署、lnmp（一）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e43l3x9.html">py-day2-3 python 字典</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
